.686
.model	flat,stdcall

includelib	kernel32.lib

EXTRN	_imp__ExitProcess@4:DWORD
EXTRN	_imp__GetCommandLineA@0:DWORD
EXTRN	_imp__lstrlen@4:DWORD
EXTRN	_imp__GetFileAttributesA@4:DWORD
EXTRN	_imp__SetFileAttributesA@8:DWORD
EXTRN	_imp__CreateFileA@28:DWORD
EXTRN	_imp__CloseHandle@4:DWORD
EXTRN	_imp__GetFileSize@8:DWORD
EXTRN	_imp__DeleteFileA@4:DWORD
EXTRN	_imp__VirtualAlloc@16:DWORD
EXTRN	_imp__VirtualFree@12:DWORD
EXTRN	_imp__WriteFile@20:DWORD
EXTRN	_imp__SetFilePointer@16:DWORD


AlignedSize	MACRO	ID:REQ, SZ:REQ, Al:REQ
	ID	EQU	(SZ + Al-1) AND -Al
ENDM

sectorSize	EQU	512
AlignedSize	buffSize, 1024*1024, sectorSize


FILE_ATTRIBUTE_READONLY	EQU	1
FILE_ATTRIBUTE_NORMAL	EQU	80h
FILE_FLAG_NO_BUFFERING	EQU	20000000h
OPEN_EXISTING	EQU	3
GENERIC_WRITE	EQU	40000000h
INVALID_HANDLE_VALUE	EQU	-1

PAGE_READWRITE	EQU	4
PAGE_NOCACHE	EQU	200h

MEM_COMMIT	EQU	1000h
MEM_RELEASE	EQU	8000h

;;FILE_BEGIN	EQU	0


.CODE
start:
	xor	ebx,ebx

	call	_imp__GetCommandLineA@0
	mov	edi,eax

	push	eax
	call	_imp__lstrlen@4

	mov	ecx,eax
	mov	al,22h
	inc	edi
	cld
	repne	scasb
	cmp	BYTE PTR [edi],20h
	jne	@F
	inc	edi

	push	edi
	call	EraseFile

@@:	push	ebx
	call	_imp__ExitProcess@4


EraseFile	PROC	USES ebx esi edi	szFileName:DWORD
LOCAL	hFile:DWORD, pBuff:DWORD, bytesWritten:DWORD
LOCAL	quotient:DWORD, remainder:DWORD
LOCAL	pattern:DWORD

	xor	ebx,ebx					;;contains ZER0
	xor	esi,esi					;;finally contains flag on success
	dec	esi					;;true flag by default
	mov	edi,szFileName

	push	edi
	call	_imp__GetFileAttributesA@4
	cmp	eax,-1
	cmovz	esi,ebx
	je	l1
	test	eax,FILE_ATTRIBUTE_READONLY
	jz	@F

	and	eax,NOT FILE_ATTRIBUTE_READONLY

	push	eax
	push	edi
	call	_imp__SetFileAttributesA@8
@@:
	push	ebx
	push	FILE_ATTRIBUTE_NORMAL OR FILE_FLAG_NO_BUFFERING
	push	OPEN_EXISTING
	push	ebx
	push	ebx
	push	GENERIC_WRITE
	push	edi
	call	_imp__CreateFileA@28
	cmp	eax,INVALID_HANDLE_VALUE
	cmovz	esi,ebx
	je	l1
	mov	hFile,eax

	push	ebx
	push	hFile
	call	_imp__GetFileSize@8
	cmp	eax,-1
	cmovz	esi,ebx
	je	l2
	test	eax,eax
	jz	l2

	add	eax,sectorSize-1
	and	eax,-sectorSize				;;fileSize divisible by sectorSize

	mov	ecx,buffSize
	xor	edx,edx
	div	ecx
	mov	quotient,eax
	mov	remainder,edx

	push	PAGE_READWRITE OR PAGE_NOCACHE
	push	MEM_COMMIT
	push	buffSize
	push	ebx
	call	_imp__VirtualAlloc@16
	test	eax,eax
	cmovz	esi,ebx
	jz	l2
	mov	pBuff,eax
	mov	edi,eax

	mov	eax,55555555h				;;the same as above [...01010101b]
	mov	pattern,eax

	push	DWORD PTR 2
cycle2:
	mov	eax,pattern
	not	eax
	mov	pattern,eax
	mov	ecx,buffSize/4
	cld
	rep	stosd
	mov	edi,pBuff

	push	ebx
	push	ebx
	push	ebx
	push	hFile
	call	_imp__SetFilePointer@16
	cmp	eax,-1
	cmovz	esi,ebx
	je	l3

	mov	esi,quotient
	test	esi,esi
	jz	next
cycle1:
	push	ebx
	lea	eax,bytesWritten
	push	eax
	push	buffSize
	push	edi
	push	hFile
	call	_imp__WriteFile@20
	test	eax,eax
	cmovz	esi,ebx
	jz	l3
	dec	esi
	jnz	cycle1

next:	dec	esi					;;esi is set again - success

	mov	edx,remainder
	test	edx,edx
	jz	next2

	push	ebx
	lea	eax,bytesWritten
	push	eax
	push	edx
	push	edi
	push	hFile
	call	_imp__WriteFile@20
	test	eax,eax
	cmovz	esi,ebx
	jz	l3
next2:
	dec	DWORD PTR [esp]
	jnz	cycle2
l3:
	add	esp,4					;;stack fixup

	push	MEM_RELEASE
	push	ebx
	push	pBuff
	call	_imp__VirtualFree@12
l2:
	push	hFile
	call	_imp__CloseHandle@4

	push	szFileName
	call	_imp__DeleteFileA@4
l1:
	and	eax,esi
	ret
EraseFile	ENDP


END	start